package com.gigachatwoot.connectors.chatwoot.controllers;

import com.gigachatwoot.connectors.chatwoot.services.CSMLResponseService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@Slf4j
@RestController
@RequestMapping("/csml")
@RequiredArgsConstructor
public class CSMLResponseController {

    private final CSMLResponseService csmlResponseService;

    @PostMapping("/response")
    public void handleCSMLResponse(@RequestBody Map<String, Object> requestBody) {
        log.info("Received CSML response: {}", requestBody);
        csmlResponseService.handleCSMLResponse(requestBody);
    }
}
