package com.gigachatwoot.connectors.chatwoot.dto;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.AllArgsConstructor;
import lombok.Data;

import java.util.List;

@Data
@AllArgsConstructor
public class CSMLRequestDTO {
    @JsonProperty("bot")
    private Bot bot;

    @JsonProperty("event")
    private Event event;

    @Data
    @AllArgsConstructor
    public static class Bot {
        @JsonProperty("id")
        private String id;

        @JsonProperty("name")
        private String name;

        @JsonProperty("default_flow")
        private String defaultFlow;

        @JsonProperty("flows")
        private List<Flow> flows;

        @Data
        @AllArgsConstructor
        public static class Flow {
            @JsonProperty("id")
            private String id;

            @JsonProperty("name")
            private String name;

            @JsonProperty("content")
            private String content;

            @JsonProperty("commands")
            private List<String> commands;
        }
    }

    @Data
    @AllArgsConstructor
    public static class Event {
        @JsonProperty("request_id")
        private String requestId;

        @JsonProperty("client")
        private Client client;

        @JsonProperty("payload")
        private Payload payload;

        @JsonProperty("metadata")
        private Metadata metadata;

        @JsonProperty("ttl_duration")
        private int ttlDuration;

        @JsonProperty("low_data_mode")
        private boolean lowDataMode;

        @Data
        @AllArgsConstructor
        public static class Client {
            @JsonProperty("bot_id")
            private String botId;

            @JsonProperty("channel_id")
            private String channelId;

            @JsonProperty("user_id")
            private String userId;
        }

        @Data
        @AllArgsConstructor
        public static class Payload {
            @JsonProperty("content_type")
            private String contentType;

            @JsonProperty("content")
            private Content content;

            @JsonProperty("secure")
            private boolean secure;

            @Data
            @AllArgsConstructor
            public static class Content {
                @JsonProperty("text")
                private String text;

                @JsonProperty("account_id")
                private Long accountId;

                @JsonProperty("conversation_id")
                private Long conversationId;

                @JsonProperty("llm_request")
                private List<CSMLMessageDTO> llmRequest;
            }
        }

        @Data
        @AllArgsConstructor
        public static class Metadata {
            @JsonProperty("username")
            private String username;

            @JsonProperty("email")
            private String email;
        }
    }
}
