package com.gigachatwoot.connectors.chatwoot.dto;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class CSMLResponseDTO {

    @JsonProperty("messages")
    private List<Message> messages;

    @JsonProperty("conversation_end")
    private boolean conversationEnd;

    @JsonProperty("request_id")
    private String requestId;

    @JsonProperty("received_at")
    private String receivedAt;

    @JsonProperty("client")
    private Client client;

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class Message {
        @JsonProperty("payload")
        private Payload payload;

        @JsonProperty("interaction_order")
        private int interactionOrder;

        @JsonProperty("conversation_id")
        private String conversationId;

        @JsonProperty("direction")
        private String direction;
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class Payload {
        @JsonProperty("content_type")
        private String contentType;

        @JsonProperty("content")
        private Content content;
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class Content {
        @JsonProperty("text")
        private String text;
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class Client {
        @JsonProperty("bot_id")
        private String botId;

        @JsonProperty("user_id")
        private String userId;

        @JsonProperty("channel_id")
        private String channelId;
    }
}
