package com.gigachatwoot.connectors.chatwoot.models;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChatwootWebhookPayload {

    @JsonProperty("event")
    private String event;

    @JsonProperty("account")
    private Account account;

    @JsonProperty("content")
    private String content;

    @JsonProperty("conversation")
    private Conversation conversation;

    @JsonProperty("message_type")
    private String messageType;

    @Data
    @JsonIgnoreProperties(ignoreUnknown = true)
    public static class Account {
        @JsonProperty("id")
        private Long id;

        @JsonProperty("name")
        private String name;
    }

    @Data
    @JsonIgnoreProperties(ignoreUnknown = true)
    public static class Conversation {
        @JsonProperty("id")
        private Long id;

        @JsonProperty("meta")
        private Meta meta;
    }

    @Data
    @JsonIgnoreProperties(ignoreUnknown = true)
    public static class Meta {
        @JsonProperty("assignee")
        private Object assignee;
    }
}
